﻿
function MyProgressTracker(options) {
    var self = this;
    this.gridId = options.gridElement;
    this.brandEditing = null;
    this.rowEditing = null;//index
    this.colEditing = null;//index
    
    this.loStartDateKey = 'LOStartDate';
    this.loEndDateKey = 'LOEndDate';
    this.loStatusKey = 'LOStatus';
    this.handbookStartDateKey = 'HandbookStartDate';
    this.handbookEndDateKey = 'HandbookEndDate';
    this.handbookStatusKey = 'HandbookStatus';
    this.testBankStartDateKey = 'TestBankStartDate';
    this.testBankEndDateKey = 'TestBankEndDate';
    this.testBankStatusKey = 'TestBankStatus';
    this.myProgressKey = 'MyProgress';
    this.myNoteKey = 'MyNote';

    this.lOStartDate = null;
    this.lOEndDate = null;
    this.lOStatus = false;
    this.hbookStartDate = null;
    this.hbookEndDate = null;
    this.hbookStatus = false;
    this.tbankStartDate = null;
    this.tbankEndDate = null;
    this.tbankStatus = false;
    this.myProgress = null;
    this.myNote = null;


    this.init = function () {
        //to do somethings
        self.initGrid();
    };

    this.initGrid = function () {

        $(self.gridId).on("iggridupdatingeditcellended", function (evt, args) {
            if (args.update) {
                $(self.gridId).igHierarchicalGrid("saveChanges");
            }
        });
        
        $(self.gridId).on("iggridupdatingeditcellstarted", function (evt, ui) {
            self.brandEditing = $(ui.editor).closest('table');//get table-child - table[data-childgrid="true"]
            self.rowEditing = ui.rowID;
            self.colEditing = ui.columnKey;
            var idx = ui.columnKey, val = ui.value;

            //do somethings...
            if (idx === self.loStartDateKey || idx === self.loEndDateKey || idx === self.handbookStartDateKey || idx === self.handbookEndDateKey || idx === self.testBankStartDateKey || idx === self.testBankEndDateKey) {
                setupCalendar(idx, ui.editor);
            }
        });

    };
    
    function setupCalendar(colKey, editor) {
        //do somethings...

        var minDate = new Date(2014, 3, 10);
        var maxDate = new Date(2014, 5, 2);
        
        $(editor).igDatePicker({
            readOnly: true,
            dateDisplayFormat: 'd MMM',
            button: 'none',
            dropDownOnReadOnly: true,
            dropDownTriggers: 'focus',
            minValue: minDate,
            maxValue: maxDate
        });
        
        $(editor).igDatePicker("show");
    }
}